/* -*- Javascript -*- */

/* global variables */

var config = new Array ();
var nbelements = 0;
var file = null;
var export_filename = 'export_alias.csv';

/* object type*/

function ConfigForm () {
  return {alias: '', dirname: '', configfile: '', description: '', func: ''};
}

/* process data */

function process_data (data) {

  /* clean previous list */
  config = new Array ();
  nbelements = 0;
  file = data;

  /* process line by line */
  var tab = data.split ('\n');
  for (var i in tab) {

    /* avoid comments and keep only host line */
    var line = tab[i].replace (/#.*/, '');
    var elements = line.split (';');
    if ((elements.length != 3) && (elements.length != 4) && (elements.length != 5))
      continue;

    config[nbelements++] = new ConfigForm ();
    config[nbelements - 1].alias = elements[0];
    config[nbelements - 1].dirname = elements[1];
    config[nbelements - 1].configfile = elements[2];
    config[nbelements - 1].description = (elements.length > 3) ? elements[3] : '';
    config[nbelements - 1].func = (elements.length > 4) ?elements[4] : '';

  }

}

/* ... */

/* import procedure */

function import_proc (data) {

  process_data (data);

  /* remove previous table */
  var table = document.getElementById ('config');
  if (!table) {
    update_status ('can\'t find previous table');
    return;
  }
  var father = table.parentNode;
  father.removeChild (table);

  /* create new table */
  table = document.createElement ('table');
  table.className = 'table';
  table.id = 'config';

  /* create header row */
  var row_config_header = table.insertRow (0);

  /* create alias column */
  var cell_config_alias_header = document.createElement('th');
  row_config_header.appendChild (cell_config_alias_header);
  cell_config_alias_header.innerHTML = 'Alias';

  /* create directory column */
  var cell_config_directory_header = document.createElement('th');
  row_config_header.appendChild (cell_config_directory_header);
  cell_config_directory_header.innerHTML = 'Directory';

  /* create configuration file column */
  var cell_config_configfile_header = document.createElement('th');
  row_config_header.appendChild (cell_config_configfile_header);
  cell_config_configfile_header.innerHTML = 'Configuration file';

  /* create description column */
  var cell_config_description_header = document.createElement('th');
  row_config_header.appendChild (cell_config_description_header);
  cell_config_description_header.innerHTML = ' Description';

  /* create function column */
  var cell_config_function_header = document.createElement('th');
  row_config_header.appendChild (cell_config_function_header);
  cell_config_function_header.innerHTML = ' Function';

  /* create table */
  for (var i in config) {

    /* create header row */
    var row_config = table.insertRow (table.rows.length);

    /* create alias entry */
    var cell_config_alias = document.createElement('td');
    cell_config_alias.className = 'expand';
    row_config.appendChild (cell_config_alias);
    var input_config_alias = document.createElement ('input');
    input_config_alias.type = 'text';
    input_config_alias.id = 'alias_' + i;
    input_config_alias.value = config[i].alias;
    cell_config_alias.appendChild (input_config_alias);

    /* create dirname entry */
    var cell_config_dirname = document.createElement('td');
    cell_config_dirname.className = 'expand';
    row_config.appendChild (cell_config_dirname);
    var input_config_dirname = document.createElement ('input');
    input_config_dirname.type = 'text';
    input_config_dirname.id = 'dirname_' + i;
    input_config_dirname.value = config[i].dirname;
    cell_config_dirname.appendChild (input_config_dirname);

    /* create configfile entry */
    var cell_config_configfile = document.createElement('td');
    cell_config_configfile.className = 'expand';
    row_config.appendChild (cell_config_configfile);
    var input_config_configfile = document.createElement ('input');
    input_config_configfile.type = 'text';
    input_config_configfile.id = 'configfile_' + i;
    input_config_configfile.value = config[i].configfile;
    cell_config_configfile.appendChild (input_config_configfile);

    /* create description entry */
    var cell_config_description = document.createElement('td');
    cell_config_description.className = 'expand';
    row_config.appendChild (cell_config_description);
    var input_config_description = document.createElement ('input');
    input_config_description.type = 'text';
    input_config_description.id = 'description_' + i;
    input_config_description.value = config[i].description;
    cell_config_description.appendChild (input_config_description);

    /* create function entry */
    var cell_config_function = document.createElement('td');
    cell_config_function.className = 'expand';
    row_config.appendChild (cell_config_function);
    var input_config_function = document.createElement ('input');
    input_config_function.type = 'text';
    input_config_function.id = 'func_' + i;
    input_config_function.value = config[i].func;
    cell_config_function.appendChild (input_config_function);


  }

  /* add new table into html page */
  father.appendChild (table);

  /* remove previous list */
  var list_dt = document.getElementById ('list');
  if (!list_dt) {
    update_status ('can\'t find previous form list');
    return;
  }
  father = list_dt.parentNode;
  father.removeChild (list_dt);

  /* create new table */
  list_dl = document.createElement ('dl');
  list_dl.id = 'list';

  /* create list */
  for (var i in config) {
    if (config[i].description != '') {
      var list_dl_dt = document.createElement ('dt');
      list_dl_dt.innerHTML = '<a href="' + config[i].alias + '">' + config[i].description + '</a>';
      list_dl.appendChild (list_dl_dt);
    }
  }

  /* add new list into html page */
  father.appendChild (list_dl);

  /* list and table are updated */
  update_status ('import done', 0);
}

/* export raw database */

function export_proc () {

  for (var i in config) {

    var ref = document.getElementById ('alias_' + i);
    config[i].alias = ref.value;
    var ref = document.getElementById ('dirname_' + i);
    config[i].dirname = ref.value;
    var ref = document.getElementById ('configfile_' + i);
    config[i].configfile = ref.value;
    var ref = document.getElementById ('description_' + i);
    config[i].description = ref.value;
    var ref = document.getElementById ('func_' + i);
    config[i].func = ref.value;

  }

  /* process line by line */
  var data = '';
  for (var i in config) {
    data += config[i].alias + ';' + config[i].dirname + ';' + config[i].configfile + ';' + config[i].description + ';' + config[i].func + '\n';
  }

  return data;
}
